//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  SeaGreen
#property indicator_color2  FireBrick
#property indicator_color3  DodgerBlue
#property indicator_color4  Magenta
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//
//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int    Lb                 = 10;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;
extern bool   alertsNotification = false;

extern bool   ShowArrows         = true;
extern int    arrowSize          = 2;
extern int    uparrowCode        = 225;
extern int    dnarrowCode        = 226;
extern bool   ArrowsOnFirstBar   = true;

//
//
//
//
//

double hi[];
double lo[];
double arrowUp[];
double arrowDn[];
double Hlv[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
 IndicatorBuffers(5);
   SetIndexBuffer(0,hi); SetIndexDrawBegin(0,Lb+1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,lo); SetIndexDrawBegin(1,Lb+1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,arrowUp);   
   SetIndexBuffer(3,arrowDn);  
   SetIndexBuffer(4,Hlv);
   
   if (ShowArrows)
   {
     SetIndexStyle(2,DRAW_ARROW,0,arrowSize); SetIndexArrow(2,uparrowCode);
     SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,dnarrowCode);   
   }
   else
   {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
   }       
   
     //
     //
     //
     //
     //
      
     indicatorFileName = WindowExpertName();
     returnBars        = TimeFrame==-99;
     TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+"  Gann HiLo activator bars");
 return(0);
}
//
//
//
//
//

int deinit(){  return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{       
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (returnBars)  { hi[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {

       for(i=limit;i>=0;i--)
       {
          Hlv[i] = Hlv[i+1];
             if(Close[i]>iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_HIGH,i+1)) Hlv[i] =  1;
             if(Close[i]<iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_LOW,i+1))  Hlv[i] = -1;
      
             if(Hlv[i] == -1)
                  { lo[i] = High[i]; hi[i] = Low[i]; }
             else { hi[i] = High[i]; lo[i] = Low[i]; }
             
             //
             //
             //
             //
             //
      
             arrowUp[i] = EMPTY_VALUE;
             arrowDn[i] = EMPTY_VALUE;
             if (Hlv[i]!= Hlv[i+1])
             if (Hlv[i] == 1)
                   arrowUp[i] = Low[i]  - iATR(NULL,0,20,i)/2.0;
             else  arrowDn[i] = High[i] + iATR(NULL,0,20,i)/2.0;
       }
       manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   int shift = -1; if (ArrowsOnFirstBar) shift=1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
   
       int y = iBarShift(NULL,TimeFrame,Time[i]);
       int x = iBarShift(NULL,TimeFrame,Time[i+shift]);
          hi[i]     = EMPTY_VALUE;
          lo[i]     = EMPTY_VALUE;
          Hlv[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Lb,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,4,y); 
         
          if(Hlv[i] == -1)
               { lo[i] = High[i]; hi[i] = Low[i]; }
          else { hi[i] = High[i]; lo[i] = Low[i]; }
       if(x!=y)
       {
          arrowUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Lb,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,2,y);
          arrowDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Lb,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,3,y);
       }
       else
       {
          arrowUp[i] = EMPTY_VALUE;
          arrowDn[i] = EMPTY_VALUE;
       }
    }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (Hlv[whichBar] != Hlv[whichBar+1])
      {
         if (Hlv[whichBar] ==  1) doAlert(whichBar,"up");
         if (Hlv[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Gann high low trend changed to ",doWhat);
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol()," Gann high low"),message);
          if (alertsNotification) SendNotification(message);
          if (alertsSound)        PlaySound("alert2.wav");
   }
}